package cn.stylefeng.team.project.modular.filing.enums;

import cn.hutool.core.util.ObjectUtil;
import cn.stylefeng.roses.kernel.rule.base.ReadableEnum;
import com.baomidou.mybatisplus.annotation.EnumValue;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import lombok.Getter;

@Getter
public enum ParseStatusEnum implements ReadableEnum<ParseStatusEnum> {

    ITEM_10(10, "进行中"),

    ITEM_20(20, "解析成功"),

    ITEM_30(30, "解析失败"),

    ITEM_40(40, "手动停止");

    @EnumValue
    @JsonValue
    private final Integer code;

    private final String message;

    ParseStatusEnum(Integer code, String message) {
        this.code = code;
        this.message = message;
    }

    @JsonCreator(mode = JsonCreator.Mode.DELEGATING)
    public static ParseStatusEnum codeToEnum(String code) {
        if (null != code) {
            for (ParseStatusEnum enumItem : ParseStatusEnum.values()) {
                if (enumItem.getCode().toString().equals(code)) {
                    return enumItem;
                }
            }
        }
        return null;
    }

    public static String codeToMessage(String code) {
        if (null != code) {
            for (ParseStatusEnum enumItem : ParseStatusEnum.values()) {
                if (enumItem.getCode().toString().equals(code)) {
                    return enumItem.getMessage();
                }
            }
        }
        return "未知";
    }

    @Override
    public Object getKey() {
        return this.code;
    }

    @Override
    public Object getName() {
        return this.message;
    }

    @Override
    public ParseStatusEnum parseToEnum(String originValue) {
        if (ObjectUtil.isEmpty(originValue)) {
            return null;
        }
        for (ParseStatusEnum value : ParseStatusEnum.values()) {
            if (value.code.toString().equals(originValue)) {
                return value;
            }
        }
        return null;
    }

}